; REM ##################
;          @set name=code
;          @GOTO compil_bin_nasm
; REM ##################

BITS 32

jmp start

; ++++++++++++++++++++++
;                MACRO 
; ++++++++++++++++++++++
    %macro get_delta 1
        call %%suivant
    %%suivant:
        pop %1
        sub %1, %%suivant
    %endmacro

; ++++++++++++++++++++++
;               DEFINE 
; ++++++++++++++++++++++
    %define delta                     ebp
    %define pushad_size	   0x20
    %define pile_seh_size	   0x8
    %define addr_retour_size    0x4
    %define size_pile_total       pushad_size+pile_seh_size+addr_retour_size
    
; ++++++++++++++++++++++
;               DATA
; ++++++++++++++++++++++
LoadLibraryA     dd 0
GetProcAddress dd 0
User32              db "user32.dll",0
MessageBoxA    db "MessageBoxA",0
Texte_defaut     db "Je suis le texte par dfaut du code relogeable. :)",0
Titre                 db "Windev... WakeUp !",0

; +++++++++++++++++++++++++++++++++++
;                   CODE RELOGEABLE
; +++++++++++++++++++++++++++++++++++
;
; DWORD WINAPI ThreadProc (PVOID pParam)
;
; +++++++++++++++++++++++++++++++++++
start:

    pushad
    get_delta delta 

    lea eax, [delta + routine_erreur]
    push eax
    push dword [fs:0]
    mov dword [fs:0], esp

    mov edi, dword [esp+size_pile_total]        ; pointeur vers le paramtre
                                                      	         ; pass au code (Thread)
; LoadLibraryA
; ------------
    mov eax, dword [edi]          
    mov dword [delta+LoadLibraryA], eax

; GetProcAddress
; -------------- 
    mov eax, dword [edi+4]          
    mov dword [delta+GetProcAddress], eax

; User32.dll
; ------------
    lea eax, [delta+User32]
    push eax
    call dword [delta+LoadLibraryA]
    mov dword [delta+User32], eax

; MessageBoxA
; ---------------
    lea eax, [delta+MessageBoxA]
    push eax
    push dword [delta+User32]
    call dword [delta+GetProcAddress]
    mov dword [delta+MessageBoxA], eax

;  Affiche le Message
; ///////////////////

; texte par defaut
    lea ebx, [delta+Texte_defaut]
    lea eax, [delta+Titre]

    mov ecx, dword [edi+8]	; table de paramtres user
    or ecx,ecx
    je saute
    mov eax, dword [ecx]	; titre de la messagebox passe en parametre
    mov ebx, dword [ecx+4]	; texte de la messagebox passe en parametre
saute :    
    push 0x10
    push eax
    push ebx
    push 0
    call dword [delta+MessageBoxA]

    xor eax,eax
    inc eax		; Code de sortie -> 1 = Tout s'est bien passe :)

sortie :
    mov esp, dword [fs:0]
    pop dword [fs:0]
    add esp,4
    mov dword [esp+01Ch], eax    ; Code de sortie
    popad
    retn 4
;---------------------------------------------

routine_erreur :
    pushad
    get_delta delta  
    mov edi, dword [esp+pushad_size+addr_retour_size+8]	; Context
    lea eax, [delta + sortie]
    mov dword [edi+0xB8], eax       ; Context.Eip
    xor eax,eax
    mov dword [edi+0xB0], eax    ; Context.Eax          ; Code de sortie -> 0 = Il y a eu un probleme :(
    popad
    xor eax,eax		; Continue Execution
    retn

; REM #####################
;                    COMPIL nasm
; REM #####################
;  :compil_bin_nasm	
;       nasmw   -O3  %name%.bat -o %name%.bin
; REM ####################

; pause





